if(!dojo._hasResource["dojox.gfx3d.lighting"]){dojo._hasResource["dojox.gfx3d.lighting"]=true;
dojo.provide("dojox.gfx3d.lighting");
dojo.require("dojox.gfx._base");
(function(){var B=dojox.gfx3d.lighting;
dojo.mixin(dojox.gfx3d.lighting,{black:function(){return{r:0,g:0,b:0,a:1}
},white:function(){return{r:1,g:1,b:1,a:1}
},toStdColor:function(A){A=dojox.gfx.normalizeColor(A);
return{r:A.r/255,g:A.g/255,b:A.b/255,a:A.a}
},fromStdColor:function(A){return new dojo.Color([Math.round(255*A.r),Math.round(255*A.g),Math.round(255*A.b),A.a])
},scaleColor:function(A,D){return{r:A*D.r,g:A*D.g,b:A*D.b,a:A*D.a}
},addColor:function(D,A){return{r:D.r+A.r,g:D.g+A.g,b:D.b+A.b,a:D.a+A.a}
},multiplyColor:function(D,A){return{r:D.r*A.r,g:D.g*A.g,b:D.b*A.b,a:D.a*A.a}
},saturateColor:function(A){return{r:A.r<0?0:A.r>1?1:A.r,g:A.g<0?0:A.g>1?1:A.g,b:A.b<0?0:A.b>1?1:A.b,a:A.a<0?0:A.a>1?1:A.a}
},mixColor:function(E,A,F){return B.addColor(B.scaleColor(F,E),B.scaleColor(1-F,A))
},diff2Color:function(I,J){var A=I.r-J.r;
var H=I.g-J.g;
var K=I.b-J.b;
var L=I.a-J.a;
return A*A+H*H+K*K+L*L
},length2Color:function(A){return A.r*A.r+A.g*A.g+A.b*A.b+A.a*A.a
},dot:function(D,A){return D.x*A.x+D.y*A.y+D.z*A.z
},scale:function(D,A){return{x:D*A.x,y:D*A.y,z:D*A.z}
},add:function(D,A){return{x:D.x+A.x,y:D.y+A.y,z:D.z+A.z}
},saturate:function(A){return Math.min(Math.max(A,0),1)
},length:function(A){return Math.sqrt(dojox.gfx3d.lighting.dot(A,A))
},normalize:function(A){return B.scale(1/B.length(A),A)
},faceforward:function(H,G){var A=dojox.gfx3d.lighting;
var F=A.dot(G,H)<0?1:-1;
return A.scale(F,H)
},reflect:function(A,E){var F=dojox.gfx3d.lighting;
return F.add(A,F.scale(-2*F.dot(A,E),E))
},diffuse:function(I,K){var A=B.black();
for(var J=0;
J<K.length;
++J){var H=K[J],L=B.dot(B.normalize(H.direction),I);
A=B.addColor(A,B.scaleColor(L,H.color))
}return B.saturateColor(A)
},specular:function(Q,O,R,L){var P=B.black();
for(var K=0;
K<L.length;
++K){var M=L[K],A=B.normalize(B.add(B.normalize(M.direction),O)),N=Math.pow(Math.max(0,B.dot(Q,A)),1/R);
P=B.addColor(P,B.scaleColor(N,M.color))
}return B.saturateColor(P)
},phong:function(R,P,N,K){R=B.normalize(R);
var Q=B.black();
for(var A=0;
A<K.length;
++A){var L=K[A],M=B.reflect(B.scale(-1,B.normalize(P)),R),O=Math.pow(Math.max(0,B.dot(M,B.normalize(L.direction))),N);
Q=B.addColor(Q,B.scaleColor(O,L.color))
}return B.saturateColor(Q)
}});
dojo.declare("dojox.gfx3d.lighting.Model",null,{constructor:function(I,K,H,A){this.incident=B.normalize(I);
this.lights=[];
for(var J=0;
J<K.length;
++J){var L=K[J];
this.lights.push({direction:B.normalize(L.direction),color:B.toStdColor(L.color)})
}this.ambient=B.toStdColor(H.color?H.color:"white");
this.ambient=B.scaleColor(H.intensity,this.ambient);
this.ambient=B.scaleColor(this.ambient.a,this.ambient);
this.ambient.a=1;
this.specular=B.toStdColor(A?A:"white");
this.specular=B.scaleColor(this.specular.a,this.specular);
this.specular.a=1;
this.npr_cool={r:0,g:0,b:0.4,a:1};
this.npr_warm={r:0.4,g:0.4,b:0.2,a:1};
this.npr_alpha=0.2;
this.npr_beta=0.6;
this.npr_scale=0.6
},constant:function(A,I,H){H=B.toStdColor(H);
var G=H.a,J=B.scaleColor(G,H);
J.a=G;
return B.fromStdColor(B.saturateColor(J))
},matte:function(A,M,I){if(typeof M=="string"){M=B.finish[M]
}I=B.toStdColor(I);
A=B.faceforward(B.normalize(A),this.incident);
var J=B.scaleColor(M.Ka,this.ambient),L=B.saturate(-4*B.dot(A,this.incident)),K=B.scaleColor(L*M.Kd,B.diffuse(A,this.lights)),N=B.scaleColor(I.a,B.multiplyColor(I,B.addColor(J,K)));
N.a=I.a;
return B.fromStdColor(B.saturateColor(N))
},metal:function(O,K,J){if(typeof K=="string"){K=B.finish[K]
}J=B.toStdColor(J);
O=B.faceforward(B.normalize(O),this.incident);
var A=B.scale(-1,this.incident),M,L,N=B.scaleColor(K.Ka,this.ambient),P=B.saturate(-4*B.dot(O,this.incident));
if("phong" in K){M=B.scaleColor(P*K.Ks*K.phong,B.phong(O,A,K.phong_size,this.lights))
}else{M=B.scaleColor(P*K.Ks,B.specular(O,A,K.roughness,this.lights))
}L=B.scaleColor(J.a,B.addColor(B.multiplyColor(J,N),B.multiplyColor(this.specular,M)));
L.a=J.a;
return B.fromStdColor(B.saturateColor(L))
},plastic:function(K,R,M){if(typeof R=="string"){R=B.finish[R]
}M=B.toStdColor(M);
K=B.faceforward(B.normalize(K),this.incident);
var O=B.scale(-1,this.incident),Q,L,A=B.scaleColor(R.Ka,this.ambient),P=B.saturate(-4*B.dot(K,this.incident)),N=B.scaleColor(P*R.Kd,B.diffuse(K,this.lights));
if("phong" in R){Q=B.scaleColor(P*R.Ks*R.phong,B.phong(K,O,R.phong_size,this.lights))
}else{Q=B.scaleColor(P*R.Ks,B.specular(K,O,R.roughness,this.lights))
}L=B.scaleColor(M.a,B.addColor(B.multiplyColor(M,B.addColor(A,N)),B.multiplyColor(this.specular,Q)));
L.a=M.a;
return B.fromStdColor(B.saturateColor(L))
},npr:function(A,Q,M){if(typeof Q=="string"){Q=B.finish[Q]
}M=B.toStdColor(M);
A=B.faceforward(B.normalize(A),this.incident);
var R=B.scaleColor(Q.Ka,this.ambient),P=B.saturate(-4*B.dot(A,this.incident)),O=B.scaleColor(P*Q.Kd,B.diffuse(A,this.lights)),L=B.scaleColor(M.a,B.multiplyColor(M,B.addColor(R,O))),N=B.addColor(this.npr_cool,B.scaleColor(this.npr_alpha,L)),S=B.addColor(this.npr_warm,B.scaleColor(this.npr_beta,L)),T=(1+B.dot(this.incident,A))/2,L=B.scaleColor(this.npr_scale,B.addColor(L,B.mixColor(N,S,T)));
L.a=M.a;
return B.fromStdColor(B.saturateColor(L))
}})
})();
dojox.gfx3d.lighting.finish={defaults:{Ka:0.1,Kd:0.6,Ks:0,roughness:0.05},dull:{Ka:0.1,Kd:0.6,Ks:0.5,roughness:0.15},shiny:{Ka:0.1,Kd:0.6,Ks:1,roughness:0.001},glossy:{Ka:0.1,Kd:0.6,Ks:1,roughness:0.0001},phong_dull:{Ka:0.1,Kd:0.6,Ks:0.5,phong:0.5,phong_size:1},phong_shiny:{Ka:0.1,Kd:0.6,Ks:1,phong:1,phong_size:200},phong_glossy:{Ka:0.1,Kd:0.6,Ks:1,phong:1,phong_size:300},luminous:{Ka:1,Kd:0,Ks:0,roughness:0.05},metalA:{Ka:0.35,Kd:0.3,Ks:0.8,roughness:1/20},metalB:{Ka:0.3,Kd:0.4,Ks:0.7,roughness:1/60},metalC:{Ka:0.25,Kd:0.5,Ks:0.8,roughness:1/80},metalD:{Ka:0.15,Kd:0.6,Ks:0.8,roughness:1/100},metalE:{Ka:0.1,Kd:0.7,Ks:0.8,roughness:1/120}}
};